{ div, a, i } = React.DOM

class @Photos extends React.Component
  constructor: (props) ->
    super props
    @state =
      url: props.url
      err: 'Indlæser billeder...'
      entity: props.entity

  @propTypes =
    url: React.PropTypes.string
    id: React.PropTypes.string
    classes: React.PropTypes.string
    entity: React.PropTypes.string

  @defaultProps: ->
    records: []
    url: ''
    id: 'oldphotos'
    classes: 'drop_zone old_files_hangar'
    entity: 'stock_item'

  componentDidMount: ->
    @loadPhotosFromServer()
    # setInterval(@loadPhotosFromServer, @props.pollInterval); # use polling, can be other eg. WebSockets

  addRecord: (record) ->
    records = React.addons.update(@state.records, { $push: [record] })
    @setState records: records

  deleteRecord: (record) =>
    index = @state.records.indexOf record
    records = React.addons.update(@state.records, { $splice: [[index, 1]] })
    @setState records: records

  render: ->
    try
      cards = []
      for record in @state.records
        cards.push React.createElement PhotoCard, { key: record.id, photo_id: record.id, record: record, deleteRecord: @deleteRecord, entity: @props.entity }

      div
        className: @props.classes
        id: @props.id
        div
          cards

    catch
      div
        className: ''
        @state.err

  loadPhotosFromServer: ->
    $.ajax
      url: @state.url,
      dataType: 'json',
      cache: false,
      success: (data) =>
        @setState {records: data}
      error: (xhr, status, err) =>
        @setState { err: err.toString() }

  #  $.ajax {
  #    url: @props.url,
  #    dataType: 'json',
  #    type: 'POST',
  #    data: comment,
